unit DID32a;

{ DID32 - DLL Interface Designer - Build nice Units for 32bits DLL

Copyright (C) 1997-2001 Paul Toth (tothpaul@free.fr)
 http://tothpaul.free.fr

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, StdCtrls, Buttons, ExtCtrls, Menus;

{-$define debug}

type
  TForm1 = class(TForm)
    Panel2: TPanel;
    MainPanel: TPanel;
    FileOpen: TSpeedButton;
    FileSave: TSpeedButton;
    Panel4: TPanel;
    SourcePanel: TPanel;
    Label1: TLabel;
    CurrentDLL: TLabel;
    OpenDlg: TOpenDialog;
    SaveDlg: TSaveDialog;
    Procs: TStringGrid;
    ProcFuncMenu: TPopupMenu;
    Function1: TMenuItem;
    Procedure1: TMenuItem;
    N1: TMenuItem;
    Comment1: TMenuItem;
    Label4: TLabel;
    Source: TMemo;
    SetSource: TSpeedButton;
    UseExternal: TCheckBox;
    Ignore1: TMenuItem;
    GetSource: TSpeedButton;
    OpenSrc: TOpenDialog;
    UseIndex: TCheckBox;
    UseStdCall: TCheckBox;
    procedure FileOpenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ProcsMouseDown(Sender: TObject; Button: TMouseButton;  Shift: TShiftState; X, Y: Integer);
    procedure SetFuncType(Sender: TObject);
    procedure ProcsSelectCell(Sender: TObject; Col, Row: Longint; var CanSelect: Boolean);
    procedure SetSourceClick(Sender: TObject);
    procedure FileSaveClick(Sender: TObject);
    procedure GetSourceClick(Sender: TObject);
    procedure UseExternalClick(Sender: TObject);
  private
    { Private-dclarations }
    DllName:string;
    ARow:longint;
    procedure Dump(f:string);
    function GetParms(i:integer):string;
    function GetParmsName(Parms:string):string;
    procedure CheckSource(Source:string);
    Procedure Add(s:string);
  public
    { Public-dclarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

Type
 TPE_FILE=packed record // 292
 {--- DOS STUB ---}

//file_header : packed record   // 24 bytes
   sign     : integer; // "PE",0,0
   pad1     : word;
   sectioncount : word;    // # of sections
   pad2     : packed array[9..24] of byte;
//end;

//  opt_header : packed array[1..96] of byte;  // 96 bytes
   { Standard fields. }
    Magic           : WORD;
    MajorLinkerVersion : Byte;
    MinorLinkerVersion : Byte;
    SizeOfCode      : DWORD;
    SizeOfInitializedData : DWORD;
    SizeOfUninitializedData : DWORD;
    AddressOfEntryPoint : DWORD;
    BaseOfCode      : DWORD;
    BaseOfData      : DWORD;
   { NT additional fields. }
    ImageBase       : DWORD;
    SectionAlignment : DWORD;
    FileAlignment   : DWORD;
    MajorOperatingSystemVersion : WORD;
    MinorOperatingSystemVersion : WORD;
    MajorImageVersion : WORD;
    MinorImageVersion : WORD;
    MajorSubsystemVersion : WORD;
    MinorSubsystemVersion : WORD;
    Reserved1       : DWORD;
    SizeOfImage     : DWORD;
    SizeOfHeaders   : DWORD;
    CheckSum        : DWORD;
    Subsystem       : WORD;
    DllCharacteristics : WORD;
    SizeOfStackReserve : DWORD;
    SizeOfStackCommit : DWORD;
    SizeOfHeapReserve : DWORD;
    SizeOfHeapCommit : DWORD;
    LoaderFlags     : DWORD;
    NumberOfRvaAndSizes : DWORD;


  data_dir   : packed array[0..15] of packed record  // 16*8 bytes
   VirtualAddress  : dword;
   Size            : dword;
  end;

  sections:packed array[0..5] of packed record
   Name                 : packed array [0..7] of Char;
   PhysicalAddress      : DWORD; // or VirtualSize (union);
   VirtualAddress       : DWORD;
   SizeOfRawData        : DWORD;
   PointerToRawData     : DWORD;
   PointerToRelocations : DWORD;
   PointerToLinenumbers : DWORD;
   NumberOfRelocations  : WORD;
   NumberOfLinenumbers  : WORD;
   Characteristics      : DWORD;
  end;

 {--- SECTIONS DATA ---}
 end;

 TEXPORTS=packed record
  Characteristics : DWORD;
  TimeDateStamp   : DWORD;
  MajorVersion    : WORD;
  MinorVersion    : WORD;
  Name            : DWORD; // DLL Name RVA
  Base            : DWORD;
  FunctionCount   : DWORD;
  NameCount       : DWORD;
  FunctionOffset  : DWORD;
  NameOffset      : DWORD;
  OrdinalOffset   : DWORD;
 end;

 TDLLScanner=class
  fFile:integer;
  fMap :integer;
  fPtr :pchar;
  fExports:TStringList;
  constructor Create(AFileName:string);
  destructor Destroy; override;
  procedure ReadExports(Ofs,RVA:integer);
 end;

Constructor TDLLScanner.Create(AFileName:string);
 var
  MZ:integer;
  PE:^TPE_FILE;
   i:integer;
  va:integer;
 begin
  fExports:=TStringList.Create;
  {$ifdef debug}allocconsole; writeln(AFileNAme);{$endif}
 // FILE MAPPING
  fFile:=CreateFile(PChar(AFileName), GENERIC_READ, FILE_SHARE_READ, nil, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
  if fFile=0 then raise Exception.Create('Couldn''t open file '+AFilename);
  fMap:=CreateFileMapping(fFile,nil,PAGE_READONLY,0,0,nil);
  if fMap=0 then raise Exception.Create('CreateFileMapping failed');
  fPtr:=MapViewOfFile(fMap, FILE_MAP_READ, 0, 0, 0);
  if fPtr=nil then raise Exception.Create('MapViewOfFile failed');
 // DOS STUB
  if word((@fPtr[0])^)<>$5A4D then raise Exception.Create('Not a MZ file');
  MZ:=integer((@fPtr[60])^);
 // PE HEADER
  PE:=@fPtr[MZ];
  if PE.Sign<>$00004550 then raise Exception.Create('Not a PE file');
 // Localize Export section
  va:=PE.Data_dir[0].VirtualAddress;
  for i:=0 to PE.SectionCount-1 do begin
   {$ifdef debug}writeln(i:3,' ',PE.Sections[i].Name);{$endif}
   with PE.Sections[i] do begin
    if (VirtualAddress<=va)and(va<VirtualAddress+SizeOfRawData) then begin // exports
     {$ifdef debug}writeln(' ok');{$endif}
     ReadExports(PointerToRawData+va-VirtualAddress,va);
     exit; // done
    end;
   end;
  end;
  // no exportation
 end;

Destructor TDLLscanner.Destroy;
 begin
  UnmapViewOfFile(fPtr);
  CloseHandle(fMap);
  CloseHandle(fFile);
  fExports.Free;
  inherited;
 end;

Procedure TDLLScanner.ReadExports(Ofs,RVA:integer);
 var
  exp:^TEXPORTS;
  i:integer;
  o:^integer;
  n:^word;
  p:pchar;
 begin // IMAGE_EXPORT_DIRECTORY
  exp:=@fPtr[Ofs];
 {$IFDEF DEBUG}
  p:=@fptr[Ofs+exp.name-RVA]; // DLL NAME
  writeln(p);
 {$ENDIF}
  o:=@fPtr[Ofs+exp.NameOffset-RVA];
  n:=@fPtr[Ofs+exp.OrdinalOffset-RVA];
  for i:=1 to exp.NameCount do begin
   p:=@fPtr[Ofs+o^-RVA];
  {$ifdef debug}writeln(p,' ',n^);{$endif}
   fExports.AddObject(p,TObject(n^));
   inc(o);
   inc(n);
  end;
 end;

//--------------

procedure TForm1.FormCreate(Sender: TObject);
begin
 With Procs do begin
  Cells[0,0]:='Proc/Func';
  Cells[1,0]:='Name';
  Cells[2,0]:='Index';
  Cells[3,0]:='Parms';
 end;
end;

procedure TForm1.FileOpenClick(Sender: TObject);
begin
 If OpenDlg.Execute then Dump(OpenDlg.FileName);
end;

procedure TForm1.dump(f:string);
 Var
  dll:file;
  i:integer;
  ds:TDLLScanner;
 begin
  SourcePanel.Hide;
  SetSource.Enabled:=true;
  GetSource.Enabled:=true;
  UseExternal.Enabled:=true;
  UseIndex.Enabled:=true;
  UseStdCall.Enabled:=true;
  DllName:=ExtractFileName(f);
  CurrentDLL.Caption:=DllName;
  SetLength(DllName,Length(DllName)-4);
  MainPanel.Show;
  Procs.RowCount:=2;
  For i:=0 to 1 do Procs.Cells[i,1]:='';

  ARow:=0;
  Procs.Col:=3;

  ds:=TDLLScanner.Create(f);
  for i:=0 to ds.fExports.Count-1 do begin
   Inc(ARow);
   Procs.RowCount:=ARow+1;
   Procs.Cells[0,ARow]:='';
   Procs.Cells[1,ARow]:=ds.fExports[i];
   Procs.Cells[2,ARow]:=IntToStr(Integer(ds.fExports.Objects[i]));
  end;
  ds.free;
 end;

procedure TForm1.ProcsMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
Var
 ACol,ARow:LongInt;
begin
 {If Button=mbRight then begin}
  With Procs do begin
   MouseToCell(X,Y,ACol,ARow);
   Col:=ACol;
   Row:=ARow;
   if (ACol=0)and(ARow>0) then ProcFuncMenu.Popup(ClientOrigin.X+X,ClientOrigin.Y+Y);
  end;
 {end;}
end;

procedure TForm1.SetFuncType(Sender: TObject);
begin
 With Procs do Cells[0,Row]:=(Sender as TMenuItem).Caption;
end;

procedure TForm1.ProcsSelectCell(Sender: TObject; Col, Row: Longint;
  var CanSelect: Boolean);
begin
 CanSelect:=(Row>0)and(Col>2);
end;

procedure TForm1.SetSourceClick(Sender: TObject);
 var
  i:integer;
  parms,call:string;
  dcl:string;
  dll:string;
begin
 SourcePanel.Show;
 Source.Lines.BeginUpdate;
 FileSave.Enabled:=True;
 Source.Clear;
 Add('{ Interface for '+CurrentDLL.Caption + ' }');
 Add('{ This Unit was build with DID322.EXE By Paul TOTH <tothpaul@free.fr> }');
 Add('Unit '+DllName+';');

 Add(#13#10'Interface'#13#10);

 if UseExternal.Checked=False then begin
  Add('Uses Windows,SysUtils;'#13#10#13#10);
  Add('Const'#13#10' '+DllName+'Handle : THandle = 0;'#13#10);
  Add('Type E'+DllName+' = class(Exception);'#13#10);
 end;

 For i:=0 to Procs.RowCount-1 do begin
  If (Procs.Cells[0,i]='Function')
  or (Procs.Cells[0,i]='Procedure') then begin
   Add(Procs.Cells[0,i]+' '+Procs.Cells[1,i]+GetParms(i));
  end;
  IF (Procs.Cells[0,i]='Comment') then
   Add('{'+Procs.Cells[1,i]+' '+Procs.Cells[3,i]+'}');
 end;

 Add(#13#10'Implementation'#13#10);

 if UseExternal.Checked=False then begin
   Add('Var');
   For i:=0 to Procs.RowCount-1 do
    if (Procs.Cells[0,i]='Function')
    or (Procs.Cells[0,i]='Procedure') then begin
     Add(' _'+Procs.Cells[1,i]+' : '+Procs.Cells[0,i]+GetParms(i));
    end;

   Add(#13#10'Procedure Free'+DLLName+'; far;');
   Add(' begin'#13#10'  FreeLibrary('+DllName+'Handle);'#13#10' end;'#13#10);

   Add('Procedure Load'+DllName+';');
   Add(' Var'#13#10'  ErrMode:Word;'#13#10' begin');
   Add('  ErrMode:=SetErrorMode(SEM_NOOPENFILEERRORBOX);');
   Add('  '+DllName+'Handle:=LoadLibrary('''+DllName+'.DLL'');');
   Add('  SetErrorMode(ErrMode);');
   Add('  If '+DllName+'Handle < 32 then begin');
   Add('   '+DllName+'Handle:=0;'#13#10'   raise E'+DllName+'.Create('''+DllName+'.DLL not found'');');
   add('  end else begin');
   add('   AddExitProc(Free'+DllName+');');
   For i:=0 to Procs.RowCount-1 do
    if (Procs.Cells[0,i]='Function')
    or (Procs.Cells[0,i]='Procedure') then begin
     add('   @_'+Procs.Cells[1,i]+':=GetProcAddress('+DllName+'Handle,'''+Procs.Cells[1,i]+''');');
    end;
   add('  end;'#13#10' end;'#13#10);
 end else begin
  dll:=UpperCase(DLLName)+'DLL';
  add('Const');
  add(' '+dll+'='''+DLLName+'.DLL'';');
  add('');
 end;

 For i:=0 to Procs.RowCount-1 do begin
  If (Procs.Cells[0,i]='Function')
  or (Procs.Cells[0,i]='Procedure') then begin
   If UseExternal.Checked then begin
    dcl:=Procs.Cells[0,i]+' '+Procs.Cells[1,i]+';';
    if UseStdcall.Checked then dcl:=dcl+' stdcall;';
    dcl:=dcl+' external '+dll;
    If UseIndex.Checked then dcl:=dcl+' index '+Procs.Cells[2,i];
    Add(dcl+';');
   end else begin
    Add(Procs.Cells[0,i]+' '+Procs.Cells[1,i]+';');
    Add(' begin');
    Add('  if '+DllName+'Handle = 0 then Load'+DllName+';');
    Parms:=GetParmsName(Procs.Cells[3,i]);
    If (Procs.Cells[0,i]='Function') then Call:='  Result:=_' else Call:=' _';
    Add(Call+Procs.Cells[1,i]+Parms+';');
    Add(' end;'#13#10);
   end;
  end;
 end;
 Add(#13#10'end.');
 Source.Lines.EndUpdate;
end;

Function TForm1.GetParms;
 Var
  p:byte;
 begin
  Result:=Procs.Cells[3,i];
  if (Result='') or (Result[Length(Result)]<>';') then Result:=Result+';';
  if UseStdCall.checked then Result:=Result+' stdcall;';
 end;

Function TForm1.GetParmsName;
 Var
  Upper:string;
  i:integer;
 begin
  { remove result }
  i:=pos(')',Parms);
  if i>0 then Parms:=Copy(Parms,1,i);
  { replace ; by ,}
  i:=pos(';',Parms);
  while i>0 do begin
   Parms[i]:=',';
   i:=pos(';',Parms);
  end;
  { remove types }
  i:=pos(':',Parms);
  while i>0 do begin
   delete(parms,i,1);
   while parms[i]=' ' do delete(parms,i,1);
   while (not (upcase(parms[i]) in [',',')']) and (i<=length(parms))) do delete(parms,i,1);
   i:=pos(':',Parms);
  end;
  { use upcase }
  Upper:=UpperCase(Parms);
  { remove VAR }
  i:=pos('VAR ',Upper);
  while i>0 do begin
   delete(Upper,i,4);
   delete(Parms,i,4);
   i:=pos('VAR ',Upper);
  end;
  { result }
  Result:=Parms;
 end;

procedure TForm1.FileSaveClick(Sender: TObject);
begin
 SaveDlg.FileName:=DLLName;
 if SaveDlg.Execute then begin
  Source.Lines.SaveToFile(SaveDlg.FileName);
  MessageDlg('Unit saved as '+SaveDlg.FileName,mtInformation,[mbOk],0);
 end;
end;

procedure TForm1.GetSourceClick(Sender: TObject);
begin
 if OpenSrc.Execute then CheckSource(OpenSrc.FileName);
end;

procedure TForm1.CheckSource(Source:string);
 Var
  Src:TextFile;
  Line,uLine:string;
  x:byte;
  Mot:string;
  spc:string;

  Procedure ReadWord;
   Procedure spaces;
    begin
     spc:='';
     while (x<=Length(line))and(line[x]=' ') do begin
      spc:=spc+' '; inc(x);
     end;
    end;
   Function AddChar:boolean;
    begin
     Mot:=Mot+Line[x];
     inc(x);
     Result:=x<=Length(uLine);
    end;
   Procedure DecimalWord;
    begin
     While (uLine[x] in ['0'..'9'])and (AddChar) do;
    end;
   procedure StringWord;
    begin
     While (uLine[x] in ['A'..'Z','_'])and(AddChar) do DecimalWord;
    end;
   begin
    spaces;
    While x>length(Line) do begin
     If Eof(Src) then raise Exception.Create('Invalid source file');
     ReadLn(Src,Line);
     uLine:=UpperCase(Line);
     x:=1;
     spaces;
    end;
    Mot:='';
    Case uLine[x] of
      'A'..'Z','_' : StringWord;
      '0'..'9'     : DecimalWord;
      else           begin Mot:=uLine[x]; inc(x); end;
    end;
   end;

  Function Skip(ToSkip:string):boolean;
   begin
    Result:=True;
    Try
     Repeat ReadWord Until UpperCase(mot)=ToSkip;
    except
     ShowMessage(ToSkip+' not found');
     Result:=False;
    end;
   end;

  procedure CheckProc;
   Var
    Kind:string;
    Row:LongInt;
    Prm:string;
   begin
    Kind:=Mot; ReadWord;
    Row:=Procs.Cols[1].IndexOf(Mot);
    If Row<0 then exit; { not found }
    Procs.Cells[0,Row]:=Kind;
    Readword; Prm:=Mot;
    if Prm='(' then begin
     Repeat
      Readword;
      Prm:=Prm+spc+Mot;
     Until Mot=')';
     ReadWord;     { : or ; }
     Prm:=Prm+Mot;
    end;
    If Mot=':' then begin
     ReadWord; Prm:=Prm+Mot; { Type }
     ReadWord; Prm:=Prm+Mot; { ; }
    end;
    Procs.Cells[3,Row]:=Prm;
   end;

  procedure doit;
   begin
    if not skip('UNIT') then exit;
    if not skip('INTERFACE') then exit;
    While Not Eof(Src) do begin
     Readword;
     If mot='Procedure' then CheckProc {getparms('Procedure')} else
     if mot='Function' then CheckProc {getparms('Function')} else
     if mot='Implementation' then break;
    end;
   end;

 begin
  FileMode:=0;
  AssignFile(Src,Source);
  Reset(Src);
  line:='';
  x:=1;
  doit;
  CloseFile(Src);
 end;

Procedure Tform1.Add(s:string);
 var i,j:word;
 begin
  i:=127;
  While i<Length(s) do begin
   j:=i;
   While not (s[j] in [',',';']) do dec(j);
   insert(#13#10' ',s,j+1);
   inc(i,127+3);
  end;
  Source.Lines.Add(s);
 end;

procedure TForm1.UseExternalClick(Sender: TObject);
begin
 UseIndex.Enabled:=UseExternal.Checked;
end;

end.
